<?php
namespace Fifa\ConnectId\Command\BulkRegistration\Helpers;

use Psr\Log\LoggerInterface;

/**
 * Class FileLogger
 * @package Fifa\ConnectId\Command\Helpers
 */
class FileLogger implements LoggerInterface
{
    /**
     * @var string
     */
    private $file;

    /**
     * FileLogger constructor.
     */
    public function __construct($file)
    {
        $this->file = $file;
    }

    /**
     * System is unusable.
     *
     * @param string $message
     * @param array $context
     * @return null
     */
    public function emergency($message, array $context = array())
    {
        $this->put("emergency: $message");
    }

    /**
     * Action must be taken immediately.
     *
     * Example: Entire website down, database unavailable, etc. This should
     * trigger the SMS alerts and wake you up.
     *
     * @param string $message
     * @param array $context
     * @return null
     */
    public function alert($message, array $context = array())
    {
        $this->put("alert: $message");
    }

    /**
     * Critical conditions.
     *
     * Example: Application component unavailable, unexpected exception.
     *
     * @param string $message
     * @param array $context
     * @return null
     */
    public function critical($message, array $context = array())
    {
        $this->put("critical: $message");
    }

    /**
     * Runtime errors that do not require immediate action but should typically
     * be logged and monitored.
     *
     * @param string $message
     * @param array $context
     * @return null
     */
    public function error($message, array $context = array())
    {
        $exceptionMessage = (isset($context['exception']) && $context['exception'] instanceof \Exception) ? $context['exception']->getMessage() : '';
        $this->put("error: $message " . $exceptionMessage);
    }

    /**
     * Exceptional occurrences that are not errors.
     *
     * Example: Use of deprecated APIs, poor use of an API, undesirable things
     * that are not necessarily wrong.
     *
     * @param string $message
     * @param array $context
     * @return null
     */
    public function warning($message, array $context = array())
    {
        $this->put("warning: $message");
    }

    /**
     * Normal but significant events.
     *
     * @param string $message
     * @param array $context
     * @return null
     */
    public function notice($message, array $context = array())
    {
        $this->put("notice: $message");
    }

    /**
     * Interesting events.
     *
     * Example: User logs in, SQL logs.
     *
     * @param string $message
     * @param array $context
     * @return null
     */
    public function info($message, array $context = array())
    {
        $this->put("info: $message");
    }

    /**
     * Detailed debug information.
     *
     * @param string $message
     * @param array $context
     * @return null
     */
    public function debug($message, array $context = array())
    {
        $this->put("debug: $message");
    }

    /**
     * Logs with an arbitrary level.
     *
     * @param mixed $level
     * @param string $message
     * @param array $context
     * @return null
     */
    public function log($level, $message, array $context = array())
    {
        $this->put("Level: $message");
    }

    private function put($message)
    {
        $logMessage = sprintf("%s %s \n", time(), $message);
        file_put_contents($this->file, $logMessage, FILE_APPEND);
        printf($logMessage);
    }
}